(*
 * YARS BATCH INCLUDED FOR HEXAPOD
 *)

let batches   = ref 0;;
let rollouts  = ref 0;;
let pi_factor = ref 0.0;;

let init nr_of_batches nr_of_rollouts pi_factor = 
  print_endline ("Initialising OCAML.");
  batches  := nr_of_batches;
  rollouts := nr_of_rollouts;
;;

let update (sensors : float array ) : float array =
  print_endline ("Roll-outs: " ^ (string_of_int !rollouts));
  print_endline ("Batches:   " ^ (string_of_int !batches));
  print_endline ("PI-Factor: " ^ (string_of_float !pi_factor));
  [| sensors.(1) *. (-3.); sensors.(0) *. (-3.);|]
;;

let close _ =
  print_endline ("Closing OCAML.");
;;

(* Export those two functions to C *)
let _ = Callback.register "init"   init;;
let _ = Callback.register "update" update;;
let _ = Callback.register "close"  close;;
