#include <caml/mlvalues.h>
#include <caml/callback.h>
#include <caml/alloc.h>
#include <caml/memory.h>


value  oi_sensors_container;
value  oi_motors_container;
int    sensor_dimension = 0;
int    motor_dimension  = 0;
static value  oi_init_container;
static value* oi_update_pointer = NULL;
static value* oi_init_pointer   = NULL;
static value* oi_close_pointer  = NULL;

void oi_init(int nr_of_sensors, int nr_of_motors)
{
	oi_sensors_container = alloc_small(nr_of_sensors      * Double_wosize, Double_array_tag);
	oi_motors_container  = alloc_small((nr_of_motors + 1) * Double_wosize, Double_array_tag); // one extra for status
  if (oi_init_pointer == NULL) oi_init_pointer = caml_named_value("init");
  caml_callback(*oi_init_pointer, oi_init_container);
	sensor_dimension = nr_of_sensors;
	motor_dimension  = nr_of_motors;
}

void oi_close()
{
  if (oi_close_pointer == NULL) oi_close_pointer = caml_named_value("close");
  caml_callback(*oi_close_pointer, NULL);
}

int oi_update(double *sensors, double *motors)
{
	int i = 0;
  if (oi_update_pointer == NULL) oi_update_pointer = caml_named_value("update");
	for(i = 0; i < sensor_dimension; i++) Store_double_field (oi_sensors_container, i, sensors[i]);
  oi_motors_container = caml_callback(*oi_update_pointer, oi_sensors_container);
	for(i = 0; i < motor_dimension; i++) motors[i] = Double_field(oi_motors_container, i);
	return (int)(Double_field(oi_motors_container, motor_dimension));
}
